---
title: List blueprints
slug: cms-saas/api/list-blueprints
docTags: 
createdAt: 2026-08-28T15:28:05.479Z
---

{
  "id": "UaipFcio_ZNh9aXvMr9LI",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://api.cms.optimizely.com/v1/blueprints",
    "servers": [
      {
        "url": "https://api.cms.optimizely.com/v1/blueprints",
        "description": "Optimizely CMS API"
      }
    ],
    "name": "List blueprints",
    "description": "List blueprints using the provided parameters.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "pageIndex",
          "type": "integer<int32>",
          "description": "Zero based index of the page that should be retrieved.",
          "format": "int32",
          "minimum": 0,
          "maximum": 10000
        },
        {
          "kind": "optional",
          "name": "pageSize",
          "type": "integer<int32>",
          "description": "The maximum items per page that should be retrieved.",
          "format": "int32",
          "minimum": 1,
          "maximum": 10000
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiAuth",
          "name": "apiAuth",
          "kind": "optional",
          "type": "oauth2",
          "description": "Use this scheme to generate an access token that can be used to access the API.",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "https://api.cms.optimizely.com/oauth/token",
              "scopes": {
                "api:admin": "Grants full administrative access to the API"
              }
            }
          },
          "requiredScopes": [
            "api:admin"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>A single page of items in a paged collection, including paging metadata such as the current page index, page size, and an estimated total item count.</p>",
            "customType": "BlueprintPage",
            "schema": [
              {
                "name": "items",
                "kind": "optional",
                "type": "array",
                "readOnly": true,
                "description": "The items in this paged collection.",
                "modelRef": "#/components/schemas/Blueprint",
                "customType": "Blueprint[]",
                "schema": [
                  {
                    "name": "key",
                    "kind": "optional",
                    "type": "string",
                    "description": "<p>The unique identifier (key) of the resource.</p>"
                  },
                  {
                    "name": "displayName",
                    "kind": "required",
                    "type": "string",
                    "description": "The display name of this blueprint.",
                    "minLength": 1,
                    "maxLength": 255
                  },
                  {
                    "name": "contentType",
                    "kind": "required",
                    "type": "string",
                    "description": "The content type of this blueprint.",
                    "minLength": 1
                  },
                  {
                    "name": "created",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "readOnly": true,
                    "description": "A timestamp indicating when this resource was first created.",
                    "format": "date-time"
                  },
                  {
                    "name": "createdBy",
                    "kind": "optional",
                    "type": "string",
                    "readOnly": true,
                    "description": "The name of the user or application that created this resource."
                  },
                  {
                    "name": "lastModified",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "readOnly": true,
                    "description": "Indicates the last time this resource was modified.",
                    "format": "date-time"
                  },
                  {
                    "name": "lastModifiedBy",
                    "kind": "optional",
                    "type": "string",
                    "readOnly": true,
                    "description": "The name of the user or application that last modified this resource."
                  },
                  {
                    "name": "content",
                    "kind": "required",
                    "type": "object",
                    "description": "The content structure of this blueprint.",
                    "modelRef": "#/components/schemas/BlueprintData",
                    "customType": "BlueprintData",
                    "schema": [],
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "ContentData",
                        "description": "",
                        "modelRef": "#/components/schemas/ContentData",
                        "schema": [
                          {
                            "name": "binding",
                            "kind": "optional",
                            "type": "object",
                            "description": "Optional binding to another content item.",
                            "modelRef": "#/components/schemas/ContentBinding",
                            "customType": "ContentBinding",
                            "schema": [
                              {
                                "name": "contentTypeBinding",
                                "kind": "optional",
                                "type": "string",
                                "description": "The binding definition key that controls how the source content item is linked and accessed."
                              },
                              {
                                "name": "source",
                                "kind": "required",
                                "type": "string<uri>",
                                "description": "The reference to the source content item that is being bound. This cannot be empty.",
                                "format": "uri"
                              }
                            ]
                          },
                          {
                            "name": "properties",
                            "kind": "optional",
                            "type": "map",
                            "description": "Properties as they are defined by corresponding component or content type.",
                            "example": "",
                            "customType": "map<string, PropertyData>",
                            "schema": []
                          }
                        ]
                      },
                      {
                        "name": "object",
                        "description": "",
                        "schema": [
                          {
                            "name": "composition",
                            "kind": "optional",
                            "type": "object",
                            "description": "<p>The composition structure of this blueprint, if any. Only relevant for blueprints of experiences and sections.</p>",
                            "modelRef": "#/components/schemas/CompositionNode",
                            "customType": "CompositionNode",
                            "schema": [
                              {
                                "name": "id",
                                "kind": "optional",
                                "type": "string",
                                "description": "Specifies an identifier of this composition node."
                              },
                              {
                                "name": "displayName",
                                "kind": "optional",
                                "type": "string",
                                "description": "The display name of this composition node.",
                                "maxLength": 255
                              },
                              {
                                "name": "nodeType",
                                "kind": "required",
                                "type": "string",
                                "description": "The node type of this composition node.",
                                "minLength": 1
                              },
                              {
                                "name": "layoutType",
                                "kind": "optional",
                                "type": "string",
                                "description": "The node layout type of this composition node"
                              },
                              {
                                "name": "displaySettings",
                                "kind": "optional",
                                "type": "object",
                                "description": "Optional display settings for the composition node.",
                                "modelRef": "#/components/schemas/CompositionDisplaySettings",
                                "customType": "CompositionDisplaySettings",
                                "schema": [
                                  {
                                    "name": "displayTemplate",
                                    "kind": "required",
                                    "type": "string",
                                    "description": "The display template that these settings apply to.",
                                    "minLength": 1
                                  },
                                  {
                                    "name": "settings",
                                    "kind": "optional",
                                    "type": "map",
                                    "nullable": true,
                                    "description": "The display settings of this composition node.",
                                    "example": "",
                                    "customType": "map<string, string>",
                                    "schema": []
                                  }
                                ]
                              },
                              {
                                "name": "component",
                                "kind": "optional",
                                "type": "object",
                                "description": "<p>Specifies the associated content for this composition node, if any.</p>",
                                "modelRef": "#/components/schemas/ContentComponent",
                                "customType": "ContentComponent",
                                "schema": [],
                                "complexType": "allOf",
                                "complexItems": [
                                  {
                                    "name": "ContentData",
                                    "description": "",
                                    "modelRef": "#/components/schemas/ContentData",
                                    "schema": [
                                      {
                                        "name": "",
                                        "description": "",
                                        "customType": "Max depth limit reached"
                                      }
                                    ]
                                  },
                                  {
                                    "name": "object",
                                    "description": "",
                                    "schema": [
                                      {
                                        "name": "reference",
                                        "kind": "optional",
                                        "type": "string<uri>",
                                        "nullable": true,
                                        "description": "A reference to the content of this component. Cannot be assigned together with 'contentType' or 'properties'.",
                                        "format": "uri"
                                      },
                                      {
                                        "name": "contentType",
                                        "kind": "optional",
                                        "type": "string",
                                        "description": "The key of the content type that this is an embedded instance of."
                                      }
                                    ]
                                  }
                                ]
                              },
                              {
                                "name": "nodes",
                                "kind": "optional",
                                "type": "array",
                                "nullable": true,
                                "description": "The child nodes for this composition node.",
                                "modelRef": "#/components/schemas/CompositionNode",
                                "customType": "CompositionNode[]",
                                "schema": [
                                  {
                                    "name": "",
                                    "description": "",
                                    "customType": "Circular-Reference"
                                  }
                                ]
                              }
                            ]
                          }
                        ]
                      }
                    ]
                  }
                ]
              },
              {
                "name": "pageIndex",
                "kind": "optional",
                "type": "integer<int32>",
                "readOnly": true,
                "description": "<p>The zero-based index of the current page.</p>",
                "format": "int32"
              },
              {
                "name": "pageSize",
                "kind": "optional",
                "type": "integer<int32>",
                "readOnly": true,
                "description": "The number of items in each page. Not necessarily the same as the number of items in this page.",
                "format": "int32"
              },
              {
                "name": "totalCount",
                "kind": "optional",
                "type": "integer<int32>",
                "readOnly": true,
                "nullable": true,
                "description": "The estimated total number of items in the collection. May be omitted if the total count is unknown.",
                "format": "int32"
              }
            ],
            "modelRef": "#/components/schemas/BlueprintPage",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "429",
        "description": "Too Many Requests",
        "jsonExample": "",
        "isExpanded": true,
        "headers": [
          {
            "kind": "optional",
            "name": "Retry-After",
            "type": "number",
            "description": "Indicates how long the client should wait before making a new request."
          }
        ],
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ProblemDetails",
            "schema": [
              {
                "name": "type",
                "kind": "optional",
                "type": "string<uri>",
                "nullable": true,
                "description": "A URI reference that identifies the problem type.",
                "format": "uri"
              },
              {
                "name": "title",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": "<p>A short, human-readable summary of the problem type.</p>"
              },
              {
                "name": "status",
                "kind": "optional",
                "type": "integer<int32>",
                "nullable": true,
                "description": "The HTTP status code generated by the origin server for this occurrence of the problem.",
                "format": "int32",
                "minimum": 100,
                "maximum": 599
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": "<p>A human-readable explanation specific to this occurrence of the problem.</p>"
              },
              {
                "name": "instance",
                "kind": "optional",
                "type": "string<uri>",
                "nullable": true,
                "description": "A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.",
                "format": "uri"
              },
              {
                "name": "code",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": "Error code that identifies the problem type."
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "array",
                "nullable": true,
                "description": "An array of error details with more detailed information about the problem.",
                "example": "",
                "itemType": "object",
                "customType": "object[]",
                "schema": [
                  {
                    "name": "detail",
                    "kind": "optional",
                    "type": "string",
                    "description": "<p>A granular explanation of one specific error related to a field, header or query parameter.</p>"
                  },
                  {
                    "name": "field",
                    "kind": "optional",
                    "type": "string",
                    "nullable": true,
                    "description": "A string that may provide a hint to which field that was the source of the error.",
                    "example": "properties.header.displayName"
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/ProblemDetails",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "500",
        "description": "Internal Server Error",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "_3mNKLSC3o8cY8fb4b_CA",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url https://api.cms.optimizely.com/v1/blueprints \\\n     --header 'accept: application/json'"
        },
        {
          "id": "hGU__0mTSYAYIC0WJenn1",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.cms.optimizely.com/v1/blueprints\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "j_EYZcVFOgaR7LXWdyBYb",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.cms.optimizely.com/v1/blueprints\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "ZehupInFiL6034sVpWwpj",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.cms.optimizely.com/v1/blueprints\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "_3mNKLSC3o8cY8fb4b_CA"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// OK\n{\n  \"items\": [\n    {\n      \"key\": \"\",\n      \"displayName\": \"\",\n      \"contentType\": \"\",\n      \"created\": \"\",\n      \"createdBy\": \"\",\n      \"lastModified\": \"\",\n      \"lastModifiedBy\": \"\",\n      \"content\": {}\n    }\n  ],\n  \"pageIndex\": \"\",\n  \"pageSize\": \"\",\n  \"totalCount\": \"\"\n}"
        },
        {
          "id": "response-1-401",
          "language": "401",
          "code": "// Unauthorized\n"
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Forbidden\n"
        },
        {
          "id": "response-3-429",
          "language": "429",
          "code": "// Too Many Requests\n{\n  \"type\": \"\",\n  \"title\": \"\",\n  \"status\": \"\",\n  \"detail\": \"\",\n  \"instance\": \"\",\n  \"code\": \"\",\n  \"errors\": [\n    {\n      \"detail\": \"\",\n      \"field\": \"properties.header.displayName\"\n    }\n  ]\n}"
        },
        {
          "id": "response-4-500",
          "language": "500",
          "code": "// Internal Server Error\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}